import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { BookingSite, BookingSiteParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageBookingSite(params: BookingSiteParam) {
  const res = await request.get<ApiResult<PageResult<BookingSite>>>(
    MODULES_API_URL + '/booking/booking-site/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listBookingSite(params?: BookingSiteParam) {
  const res = await request.get<ApiResult<BookingSite[]>>(
    MODULES_API_URL + '/booking/booking-site',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addBookingSite(data: BookingSite) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-site',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateBookingSite(data: BookingSite) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-site',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeBookingSite(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-site/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchBookingSite(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-site/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getBookingSite(id: number) {
  const res = await request.get<ApiResult<BookingSite>>(
    MODULES_API_URL + '/booking/booking-site/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
